%
%  wavelet_synth_srs_plot.m  ver 1.1  by Tom Irvine
%
function[Shock_Response_Spectrum,fig_num]=...
          wavelet_synth_srs_plot(f,fr,xmax,xmin,aspec,damp,iunit,fig_num)
%

try
    close fig_num
end
try
    close fig_num hidden
end     

figure(fig_num);
fig_num=fig_num+1;
plot(f,xmax,'blue',f,xmin,'red',fr,aspec,'black');
%
Shock_Response_Spectrum=[f',xmax,xmin];
%
if(iunit==3)
              ylabel('Peak Accel (m/sec^2)');
else
              ylabel('Peak Accel (G)');               
end
xlabel('Natural Frequency (Hz)');
legend ('positive','negative','spec & tol');  
set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale','log','YScale','log');  
clear Q;
Q = 1/(2*damp);
out5 = sprintf(' Shock Response Spectrum Q=%g ',Q);
title(out5);   
grid on;
hold on;
plot(fr,aspec/sqrt(2),'black',fr,aspec*sqrt(2),'black');
hold off;
%
%
srs_max=max(aspec*sqrt(2));
srs_min=min(aspec/sqrt(2));
ymax= 10^(round(log10(srs_max)+0.8));
ymin= 10^(round(log10(srs_min)-0.6));
%
fmin=f(1);
fmax=max(f);

[xtt,xTT,iflag]=xtick_label(fmin,fmax);

if(iflag==1)
    set(gca,'xtick',xtt);
    set(gca,'XTickLabel',xTT);
end   

fmin=xtt(1);
fmax=max(xtt);

axis([fmin,fmax,ymin,ymax]);

h = get(gca, 'title');
set(h, 'FontName', 'Arial','FontSize',11)
h = get(gca, 'xlabel');
set(h, 'FontName', 'Arial','FontSize',11)
h = get(gca, 'ylabel');
set(h, 'FontName', 'Arial','FontSize',11)
%     